module RAM #(
  parameter BITS = 8
)(
  input                 i_clk,
  input                 i_ri,
  input                 i_ro,
  input      [BITS-1:0] i_mar,
  inout      [BITS-1:0] io_bus,
  input                 i_bus_active,
  output     [BITS-1:0] o_ram
);
reg [BITS-1:0] ram[0:6650]; //min 6650 for 16bit primes (6542 primes + 90 program )
initial begin
  if (BITS==8)
    $readmemh ("primes_8.ram", ram); //test.ram",ram); //
  else if (BITS==16)
    $readmemh ("primes_16.ram", ram); //test.ram",ram); //
end

always @(posedge i_clk) begin
  if (i_ri)
    ram[i_mar] <= (i_bus_active) ? io_bus : (BITS)'d0;
end

assign o_ram = ram[i_mar];
assign io_bus = i_ro ? ram[i_mar] : {BITS{1'bz}};//zbits;//16'bz;

endmodule
